Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4451)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4452)
@@ -28,31 +28,34 @@
 ! -----------------
 ! $Id$
-! - Change order of dimension in surface arrays %frac, %emissivity and %albedo 
+! Bugfix in calc_albedo
+!
+! 4442 2020-03-04 19:21:13Z suehring
+! - Change order of dimension in surface arrays %frac, %emissivity and %albedo
 !   to allow for better vectorization in the radiation interactions.
 ! - Minor formatting issues
-! 
+!
 ! 4441 2020-03-04 19:20:35Z suehring
 ! bugfixes: cpp-directives for serial mode moved, small changes to get serial mode compiled
-! 
+!
 ! 4400 2020-02-10 20:32:41Z suehring
 ! Initialize radiation arrays with zero
-! 
+!
 ! 4392 2020-01-31 16:14:57Z pavelkrc
 ! - Add debug tracing of large radiative fluxes (option trace_fluxes_above)
 ! - Print exact counts of SVF and CSF if debut_output is enabled
 ! - Update descriptions of RTM 3.0 and related comments
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Renamed pc_heating_rate, pc_transpiration_rate, pc_transpiration_rate to
 ! pcm_heating_rate, pcm_latent_rate, pcm_transpiration_rate
-! 
+!
 ! 4340 2019-12-16 08:17:03Z Giersch
-! Albedo indices for building_surface_pars are now declared as parameters to 
+! Albedo indices for building_surface_pars are now declared as parameters to
 ! prevent an error if the gfortran compiler with -Werror=unused-value is used
-!  
+!
 ! 4291 2019-11-11 12:36:54Z moh.hefny
-! Enabled RTM in case of biometeorology even if there is no vertical 
+! Enabled RTM in case of biometeorology even if there is no vertical
 ! surfaces or 3D vegetation in the domain
-! 
+!
 ! 4286 2019-10-30 16:01:14Z resler
 ! - Fix wrong treating of time_rad during interpolation in radiation_model_mod
@@ -62,18 +65,18 @@
 ! 4271 2019-10-23 10:46:41Z maronga
 ! Bugfix: missing parentheses in calculation of snow albedo
-! 
+!
 ! 4245 2019-09-30 08:40:37Z pavelkrc
 ! Initialize explicit per-surface albedos from building_surface_pars
-! 
+!
 ! 4238 2019-09-25 16:06:01Z suehring
 ! Modify check in order to avoid equality comparisons of floating points
-! 
+!
 ! 4227 2019-09-10 18:04:34Z gronemeier
 ! implement new palm_date_time_mod
-! 
+!
 ! 4226 2019-09-10 17:03:24Z suehring
 ! - Netcdf input routine for dimension length renamed
-! - Define time variable for external radiation input relative to time_utc_init 
-! 
+! - Define time variable for external radiation input relative to time_utc_init
+!
 ! 4210 2019-09-02 13:07:09Z suehring
 ! - Revise steering of splitting diffuse and direct radiation
@@ -81,67 +84,67 @@
 ! - Optimize mapping of radiation components onto 2D arrays, avoid unnecessary
 !   operations
-! 
+!
 ! 4208 2019-09-02 09:01:07Z suehring
 ! Bugfix in accessing albedo_pars in the clear-sky branch
-! (merge from branch resler) 
-! 
+! (merge from branch resler)
+!
 ! 4198 2019-08-29 15:17:48Z gronemeier
 ! Prohibit execution of radiation model if rotation_angle is not zero
-! 
+!
 ! 4197 2019-08-29 14:33:32Z suehring
 ! Revise steering of surface albedo initialization when albedo_pars is provided
-! 
+!
 ! 4190 2019-08-27 15:42:37Z suehring
-! Implement external radiation forcing also for level-of-detail = 2 
+! Implement external radiation forcing also for level-of-detail = 2
 ! (horizontally 2D radiation)
-! 
+!
 ! 4188 2019-08-26 14:15:47Z suehring
 ! Minor adjustment in error message
-! 
+!
 ! 4187 2019-08-26 12:43:15Z suehring
-! - Take external radiation from root domain dynamic input if not provided for 
+! - Take external radiation from root domain dynamic input if not provided for
 !   each nested domain
 ! - Combine MPI_ALLREDUCE calls to reduce mpi overhead
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4179 2019-08-21 11:16:12Z suehring
 ! Remove debug prints
-! 
+!
 ! 4178 2019-08-21 11:13:06Z suehring
 ! External radiation forcing implemented.
-! 
+!
 ! 4168 2019-08-16 13:50:17Z suehring
 ! Replace function get_topography_top_index by topo_top_ind
-! 
+!
 ! 4157 2019-08-14 09:19:12Z suehring
 ! Give informative message on raytracing distance only by core zero
-! 
+!
 ! 4148 2019-08-08 11:26:00Z suehring
 ! Comments added
-! 
+!
 ! 4134 2019-08-02 18:39:57Z suehring
 ! Bugfix in formatted write statement
-! 
+!
 ! 4127 2019-07-30 14:47:10Z suehring
 ! Remove unused pch_index (merge from branch resler)
-! 
+!
 ! 4089 2019-07-11 14:30:27Z suehring
 ! - Correct level 2 initialization of spectral albedos in rrtmg branch, long- and
-!   shortwave albedos were mixed-up. 
+!   shortwave albedos were mixed-up.
 ! - Change order of albedo_pars so that it is now consistent with the defined
-!   order of albedo_pars in PIDS 
-! 
+!   order of albedo_pars in PIDS
+!
 ! 4069 2019-07-01 14:05:51Z Giersch
-! Masked output running index mid has been introduced as a local variable to 
+! Masked output running index mid has been introduced as a local variable to
 ! avoid runtime error (Loop variable has been modified) in time_integration
-! 
+!
 ! 4067 2019-07-01 13:29:25Z suehring
 ! Bugfix, pass dummy string to MPI_INFO_SET (J. Resler)
-! 
+!
 ! 4039 2019-06-18 10:32:41Z suehring
 ! Bugfix for masked data output
-! 
+!
 ! 4008 2019-05-30 09:50:11Z moh.hefny
 ! Bugfix in check variable when a variable's string is less than 3
@@ -150,46 +153,46 @@
 !
 ! 3992 2019-05-22 16:49:38Z suehring
-! Bugfix in rrtmg radiation branch in a nested run when the lowest prognistic 
-! grid points in a child domain are all inside topography 
-! 
+! Bugfix in rrtmg radiation branch in a nested run when the lowest prognistic
+! grid points in a child domain are all inside topography
+!
 ! 3987 2019-05-22 09:52:13Z kanani
 ! Introduce alternative switch for debug output during timestepping
-! 
+!
 ! 3943 2019-05-02 09:50:41Z maronga
 ! Missing blank characteer added.
-! 
+!
 ! 3900 2019-04-16 15:17:43Z suehring
 ! Fixed initialization problem
-! 
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
+! Changes related to global restructuring of location messages and introduction
 ! of additional debug messages
-! 
+!
 ! 3881 2019-04-10 09:31:22Z suehring
 ! Output of albedo and emissivity moved from USM, bugfixes in initialization
 ! of albedo
-! 
+!
 ! 3861 2019-04-04 06:27:41Z maronga
 ! Bugfix: factor of 4.0 required instead of 3.0 in calculation of rad_lw_out_change_0
-! 
+!
 ! 3859 2019-04-03 20:30:31Z maronga
 ! Added some descriptions
-! 
+!
 ! 3847 2019-04-01 14:51:44Z suehring
 ! Implement check for dt_radiation (must be > 0)
-! 
+!
 ! 3846 2019-04-01 13:55:30Z suehring
 ! unused variable removed
-! 
+!
 ! 3814 2019-03-26 08:40:31Z pavelkrc
 ! Change zenith(0:0) and others to scalar.
 ! Code review.
 ! Rename exported nzu, nzp and related variables due to name conflict
-! 
+!
 ! 3771 2019-02-28 12:19:33Z raasch
 ! rrtmg preprocessor for directives moved/added, save attribute added to temporary
 ! pointers to avoid compiler warnings about outlived pointer targets,
 ! statement added to avoid compiler warning about unused variable
-! 
+!
 ! 3769 2019-02-28 10:16:49Z moh.hefny
 ! removed unused variables and subroutine radiation_radflux_gridbox
@@ -197,5 +200,5 @@
 ! 3767 2019-02-27 08:18:02Z raasch
 ! unused variable for file index removed from rrd-subroutines parameter list
-! 
+!
 ! 3760 2019-02-21 18:47:35Z moh.hefny
 ! Bugfix: initialized simulated_time before calculating solar position
@@ -205,6 +208,6 @@
 ! (resler, pavelkrc)
 ! Bugfixes: add further required MRT factors to read/write_svf,
-! fix for aggregating view factors to eliminate local noise in reflected 
-! irradiance at mutually close surfaces (corners, presence of trees) in the 
+! fix for aggregating view factors to eliminate local noise in reflected
+! irradiance at mutually close surfaces (corners, presence of trees) in the
 ! angular discretization scheme.
 !
@@ -213,18 +216,18 @@
 !
 ! 3705 2019-01-29 19:56:39Z suehring
-! Make variables that are sampled in virtual measurement module public 
-! 
+! Make variables that are sampled in virtual measurement module public
+!
 ! 3704 2019-01-29 19:51:41Z suehring
 ! Some interface calls moved to module_interface + cleanup
-! 
+!
 ! 3667 2019-01-10 14:26:24Z schwenkel
 ! Modified check for rrtmg input files
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! nopointer option removed
-! 
+!
 ! 1496 2014-12-02 17:25:50Z maronga
 ! Initial revision
-! 
+!
 !
 ! Description:
@@ -247,5 +250,5 @@
 !------------------------------------------------------------------------------!
  MODULE radiation_model_mod
- 
+
     USE arrays_3d,                                                             &
         ONLY:  dzw, hyp, nc, pt, p, q, ql, u, v, w, zu, zw, exner, d_exner
@@ -276,5 +279,5 @@
 
     USE grid_variables,                                                        &
-         ONLY:  ddx, ddy, dx, dy 
+         ONLY:  ddx, ddy, dx, dy
 
     USE indices,                                                               &
@@ -366,8 +369,8 @@
 !-- Predefined Land surface classes (albedo_type) after Briegleb (1992)
     CHARACTER(37), DIMENSION(0:33), PARAMETER :: albedo_type_name = (/      &
-                                   'user defined                         ', & !  0 
+                                   'user defined                         ', & !  0
                                    'ocean                                ', & !  1
                                    'mixed farming, tall grassland        ', & !  2
-                                   'tall/medium grassland                ', & !  3 
+                                   'tall/medium grassland                ', & !  3
                                    'evergreen shrubland                  ', & !  4
                                    'short grassland/meadow/shrubland     ', & !  5
@@ -377,9 +380,9 @@
                                    'tropical evergreen broadleaved forest', & !  9
                                    'medium/tall grassland/woodland       ', & ! 10
-                                   'desert, sandy                        ', & ! 11 
-                                   'desert, rocky                        ', & ! 12 
+                                   'desert, sandy                        ', & ! 11
+                                   'desert, rocky                        ', & ! 12
                                    'tundra                               ', & ! 13
-                                   'land ice                             ', & ! 14 
-                                   'sea ice                              ', & ! 15 
+                                   'land ice                             ', & ! 14
+                                   'sea ice                              ', & ! 15
                                    'snow                                 ', & ! 16
                                    'bare soil                            ', & ! 17
@@ -415,5 +418,5 @@
 
     INTEGER(iwp) :: albedo_type  = 9999999_iwp, &     !< Albedo surface type
-                    dots_rad     = 0_iwp              !< starting index for timeseries output 
+                    dots_rad     = 0_iwp              !< starting index for timeseries output
 
     LOGICAL ::  unscheduled_radiation_calls = .TRUE., & !< flag parameter indicating whether additional calls of the radiation code are allowed
@@ -467,7 +470,7 @@
     REAL(wp), PARAMETER :: emissivity_atm_clsky = 0.8_wp       !< emissivity of the clear-sky atmosphere
 !
-!-- Land surface albedos for solar zenith angle of 60degree after Briegleb (1992)     
+!-- Land surface albedos for solar zenith angle of 60degree after Briegleb (1992)
 !-- (broadband, longwave, shortwave ):   bb,      lw,      sw,
-    REAL(wp), DIMENSION(0:2,1:33), PARAMETER :: albedo_pars = RESHAPE( (/& 
+    REAL(wp), DIMENSION(0:2,1:33), PARAMETER :: albedo_pars = RESHAPE( (/&
                                    0.06_wp, 0.06_wp, 0.06_wp,            & !  1
                                    0.19_wp, 0.28_wp, 0.09_wp,            & !  2
@@ -541,5 +544,5 @@
 
 !
-!-- The following variables should be only changed with care, as this will 
+!-- The following variables should be only changed with care, as this will
 !-- require further setting of some variables, which is currently not
 !-- implemented (aerosols, ice phase).
@@ -570,5 +573,5 @@
                                              rrtm_cliqwp,    & !< in-cloud liquid water path (g/m2)
                                              rrtm_co2vmr,    & !< CO2 volume mixing ratio (g/mol)
-                                             rrtm_emis,      & !< surface emissivity (0-1)  
+                                             rrtm_emis,      & !< surface emissivity (0-1)
                                              rrtm_h2ovmr,    & !< H2O volume mixing ratio
                                              rrtm_n2ovmr,    & !< N2O volume mixing ratio
@@ -582,5 +585,5 @@
                                              rrtm_tlev,      & !< actual temperature (K, zw-grid)
                                              rrtm_lwdflx,    & !< RRTM output of incoming longwave radiation flux (W/m2)
-                                             rrtm_lwdflxc,   & !< RRTM output of outgoing clear sky longwave radiation flux (W/m2) 
+                                             rrtm_lwdflxc,   & !< RRTM output of outgoing clear sky longwave radiation flux (W/m2)
                                              rrtm_lwuflx,    & !< RRTM output of outgoing longwave radiation flux (W/m2)
                                              rrtm_lwuflxc,   & !< RRTM output of incoming clear sky longwave radiation flux (W/m2)
@@ -590,11 +593,11 @@
                                              rrtm_lwhrc,     & !< RRTM output of incoming longwave clear sky radiation heating rate (K/d)
                                              rrtm_swdflx,    & !< RRTM output of incoming shortwave radiation flux (W/m2)
-                                             rrtm_swdflxc,   & !< RRTM output of outgoing clear sky shortwave radiation flux (W/m2) 
+                                             rrtm_swdflxc,   & !< RRTM output of outgoing clear sky shortwave radiation flux (W/m2)
                                              rrtm_swuflx,    & !< RRTM output of outgoing shortwave radiation flux (W/m2)
                                              rrtm_swuflxc,   & !< RRTM output of incoming clear sky shortwave radiation flux (W/m2)
                                              rrtm_swhr,      & !< RRTM output of shortwave radiation heating rate (K/d)
-                                             rrtm_swhrc,     & !< RRTM output of incoming shortwave clear sky radiation heating rate (K/d) 
-                                             rrtm_dirdflux,  & !< RRTM output of incoming direct shortwave (W/m2) 
-                                             rrtm_difdflux     !< RRTM output of incoming diffuse shortwave (W/m2) 
+                                             rrtm_swhrc,     & !< RRTM output of incoming shortwave clear sky radiation heating rate (K/d)
+                                             rrtm_dirdflux,  & !< RRTM output of incoming direct shortwave (W/m2)
+                                             rrtm_difdflux     !< RRTM output of incoming diffuse shortwave (W/m2)
 
     REAL(wp), DIMENSION(1) ::                rrtm_aldif,     & !< surface albedo for longwave diffuse radiation
@@ -734,16 +737,16 @@
 !-- type for calculation of svf
     TYPE t_svf
-        INTEGER(iwp)                               :: isurflt           !< 
-        INTEGER(iwp)                               :: isurfs            !< 
-        REAL(wp)                                   :: rsvf              !< 
-        REAL(wp)                                   :: rtransp           !< 
+        INTEGER(iwp)                               :: isurflt           !<
+        INTEGER(iwp)                               :: isurfs            !<
+        REAL(wp)                                   :: rsvf              !<
+        REAL(wp)                                   :: rtransp           !<
     END TYPE
 
 !-- type for calculation of csf
     TYPE t_csf
-        INTEGER(iwp)                               :: ip                !< 
-        INTEGER(iwp)                               :: itx               !< 
-        INTEGER(iwp)                               :: ity               !< 
-        INTEGER(iwp)                               :: itz               !< 
+        INTEGER(iwp)                               :: ip                !<
+        INTEGER(iwp)                               :: itx               !<
+        INTEGER(iwp)                               :: ity               !<
+        INTEGER(iwp)                               :: itz               !<
         INTEGER(iwp)                               :: isurfs            !< Idx of source face / -1 for sky
         REAL(wp)                                   :: rcvf              !< Canopy view factor for faces /
@@ -788,5 +791,5 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinswdif      !< array of diffuse sw radiation from sky and model boundary falling to local surface
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinlwdif      !< array of diffuse lw radiation from sky and model boundary falling to local surface
-    
+
                                                                         !< Outward radiation is only valid for nonvirtual surfaces
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutsl        !< array of reflected sw radiation for local surface in i-th reflection
@@ -835,5 +838,5 @@
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE      ::  boxes            !< coordinates of gridboxes being crossed by ray
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  crlens           !< array of crossing lengths of ray for particular grid boxes
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  lad_ip           !< array of numbers of process where lad is stored 
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  lad_ip           !< array of numbers of process where lad is stored
 #if defined( __parallel )
     INTEGER(kind=MPI_ADDRESS_KIND), &
@@ -876,10 +879,10 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: emiss_surf         !< emissivity of the wall surface
 !
-!-- External radiation. Depending on the given level of detail either a 1D or 
+!-- External radiation. Depending on the given level of detail either a 1D or
 !-- a 3D array will be allocated.
-    TYPE( real_1d_3d ) ::  rad_lw_in_f     !< external incoming longwave radiation, from observation or model 
-    TYPE( real_1d_3d ) ::  rad_sw_in_f     !< external incoming shortwave radiation, from observation or model 
+    TYPE( real_1d_3d ) ::  rad_lw_in_f     !< external incoming longwave radiation, from observation or model
+    TYPE( real_1d_3d ) ::  rad_sw_in_f     !< external incoming shortwave radiation, from observation or model
     TYPE( real_1d_3d ) ::  rad_sw_in_dif_f !< external incoming shortwave radiation, diffuse part, from observation or model
-    TYPE( real_1d_3d ) ::  time_rad_f      !< time dimension for external radiation, from observation or model 
+    TYPE( real_1d_3d ) ::  time_rad_f      !< time dimension for external radiation, from observation or model
 
     INTERFACE radiation_check_data_output
@@ -894,17 +897,17 @@
        MODULE PROCEDURE radiation_check_data_output_pr
     END INTERFACE radiation_check_data_output_pr
-  
+
     INTERFACE radiation_check_parameters
        MODULE PROCEDURE radiation_check_parameters
     END INTERFACE radiation_check_parameters
-  
+
     INTERFACE radiation_clearsky
        MODULE PROCEDURE radiation_clearsky
     END INTERFACE radiation_clearsky
- 
+
     INTERFACE radiation_constant
        MODULE PROCEDURE radiation_constant
     END INTERFACE radiation_constant
- 
+
     INTERFACE radiation_control
        MODULE PROCEDURE radiation_control
@@ -933,6 +936,6 @@
     INTERFACE radiation_header
        MODULE PROCEDURE radiation_header
-    END INTERFACE radiation_header 
-  
+    END INTERFACE radiation_header
+
     INTERFACE radiation_init
        MODULE PROCEDURE radiation_init
@@ -942,5 +945,5 @@
        MODULE PROCEDURE radiation_parin
     END INTERFACE radiation_parin
-    
+
     INTERFACE radiation_rrtmg
        MODULE PROCEDURE radiation_rrtmg
@@ -969,5 +972,5 @@
        MODULE PROCEDURE radiation_interaction_init
     END INTERFACE radiation_interaction_init
- 
+
     INTERFACE radiation_presimulate_solar_pos
        MODULE PROCEDURE radiation_presimulate_solar_pos
@@ -1005,5 +1008,5 @@
            radiation_read_svf, radiation_presimulate_solar_pos
 
-    
+
 !
 !-- Public variables and constants / NEEDS SORTING
@@ -1042,6 +1045,6 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE radiation_control
- 
- 
+
+
        IMPLICIT NONE
 
@@ -1054,11 +1057,11 @@
           CASE ( 'constant' )
              CALL radiation_constant
-          
-          CASE ( 'clear-sky' ) 
+
+          CASE ( 'clear-sky' )
              CALL radiation_clearsky
-       
+
           CASE ( 'rrtmg' )
              CALL radiation_rrtmg
-             
+
           CASE ( 'external' )
 !
@@ -1084,6 +1087,6 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE radiation_check_data_output( variable, unit, i, ilen, k )
- 
- 
+
+
        USE control_parameters,                                                 &
            ONLY: data_output, message_string
@@ -1262,8 +1265,8 @@
 ! ------------
 !> Check data output of profiles for radiation model
-!------------------------------------------------------------------------------!  
+!------------------------------------------------------------------------------!
     SUBROUTINE radiation_check_data_output_pr( variable, var_count, unit,      &
                dopr_unit )
- 
+
        USE arrays_3d,                                                          &
            ONLY: zu
@@ -1279,13 +1282,13 @@
 
        IMPLICIT NONE
-   
-       CHARACTER (LEN=*) ::  unit      !< 
-       CHARACTER (LEN=*) ::  variable  !< 
+
+       CHARACTER (LEN=*) ::  unit      !<
+       CHARACTER (LEN=*) ::  variable  !<
        CHARACTER (LEN=*) ::  dopr_unit !< local value of dopr_unit
- 
-       INTEGER(iwp) ::  var_count     !< 
+
+       INTEGER(iwp) ::  var_count     !<
 
        SELECT CASE ( TRIM( variable ) )
-       
+
          CASE ( 'rad_net' )
              IF ( (  .NOT.  radiation )  .OR.  radiation_scheme == 'constant' )&
@@ -1315,5 +1318,5 @@
                 dopr_unit  = 'W/m2'
                 hom(:,2,100,:)  = SPREAD( zw, 2, statistic_regions+1 )
-                unit = dopr_unit 
+                unit = dopr_unit
              ENDIF
 
@@ -1330,5 +1333,5 @@
                 dopr_unit  = 'W/m2'
                 hom(:,2,101,:)  = SPREAD( zw, 2, statistic_regions+1 )
-                unit = dopr_unit   
+                unit = dopr_unit
              ENDIF
 
@@ -1431,6 +1434,6 @@
 
     END SUBROUTINE radiation_check_data_output_pr
- 
- 
+
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -1444,11 +1447,11 @@
 
        USE netcdf_data_input_mod,                                              &
-           ONLY:  input_pids_static                 
-    
+           ONLY:  input_pids_static
+
        IMPLICIT NONE
-       
-!
-!--    In case no urban-surface or land-surface model is applied, usage of 
-!--    a radiation model make no sense.         
+
+!
+!--    In case no urban-surface or land-surface model is applied, usage of
+!--    a radiation model make no sense.
        IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
           message_string = 'Usage of radiation module is only allowed if ' //  &
@@ -1466,5 +1469,5 @@
        ELSEIF ( radiation_scheme == 'rrtmg' )  THEN
 #if ! defined ( __rrtmg )
-          message_string = 'radiation_scheme = "rrtmg" requires ' //           & 
+          message_string = 'radiation_scheme = "rrtmg" requires ' //           &
                            'compilation of PALM with pre-processor ' //        &
                            'directive -D__rrtmg'
@@ -1472,5 +1475,5 @@
 #endif
 #if defined ( __rrtmg ) && ! defined( __netcdf )
-          message_string = 'radiation_scheme = "rrtmg" requires ' //           & 
+          message_string = 'radiation_scheme = "rrtmg" requires ' //           &
                            'the use of NetCDF (preprocessor directive ' //     &
                            '-D__netcdf'
@@ -1480,9 +1483,9 @@
        ENDIF
 !
-!--    Checks performed only if data is given via namelist only. 
+!--    Checks performed only if data is given via namelist only.
        IF ( .NOT. input_pids_static )  THEN
           IF ( albedo_type == 0  .AND.  albedo == 9999999.9_wp  .AND.          &
                radiation_scheme == 'clear-sky')  THEN
-             message_string = 'radiation_scheme = "clear-sky" in combination'//& 
+             message_string = 'radiation_scheme = "clear-sky" in combination'//&
                               'with albedo_type = 0 requires setting of'//     &
                               'albedo /= 9999999.9'
@@ -1492,7 +1495,7 @@
           IF ( albedo_type == 0  .AND.  radiation_scheme == 'rrtmg'  .AND.     &
              ( albedo_lw_dif == 9999999.9_wp .OR. albedo_lw_dir == 9999999.9_wp&
-          .OR. albedo_sw_dif == 9999999.9_wp .OR. albedo_sw_dir == 9999999.9_wp& 
+          .OR. albedo_sw_dif == 9999999.9_wp .OR. albedo_sw_dir == 9999999.9_wp&
              ) ) THEN
-             message_string = 'radiation_scheme = "rrtmg" in combination' //   & 
+             message_string = 'radiation_scheme = "rrtmg" in combination' //   &
                               'with albedo_type = 0 requires setting of ' //   &
                               'albedo_lw_dif /= 9999999.9' //                  &
@@ -1506,5 +1509,5 @@
 !--    Parallel rad_angular_discretization without raytrace_mpi_rma is not implemented
 !--    Serial mode does not allow mpi_rma
-#if defined( __parallel )      
+#if defined( __parallel )
        IF ( rad_angular_discretization  .AND.  .NOT. raytrace_mpi_rma )  THEN
           message_string = 'rad_angular_discretization can only be used ' //  &
@@ -1522,5 +1525,5 @@
        IF ( cloud_droplets  .AND.   radiation_scheme == 'rrtmg'  .AND.         &
             average_radiation ) THEN
-          message_string = 'average_radiation = .T. with radiation_scheme'//   & 
+          message_string = 'average_radiation = .T. with radiation_scheme'//   &
                            '= "rrtmg" in combination cloud_droplets = .T.'//   &
                            'is not implementd'
@@ -1539,6 +1542,6 @@
 !--    Check for dt_radiation
        IF ( dt_radiation <= 0.0 )  THEN
-          message_string = 'dt_radiation must be > 0.0'  
-          CALL message( 'check_parameters', 'PA0591', 1, 2, 0, 6, 0 ) 
+          message_string = 'dt_radiation must be > 0.0'
+          CALL message( 'check_parameters', 'PA0591', 1, 2, 0, 6, 0 )
        ENDIF
 !
@@ -1549,10 +1552,10 @@
                            'model.&Using rotation_angle /= 0.0 is not allowed in combination ' //  &
                            'with the radiation model at the moment!'
-          CALL message( 'check_parameters', 'PA0675', 1, 2, 0, 6, 0 ) 
+          CALL message( 'check_parameters', 'PA0675', 1, 2, 0, 6, 0 )
        ENDIF
- 
-    END SUBROUTINE radiation_check_parameters 
- 
- 
+
+    END SUBROUTINE radiation_check_parameters
+
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -1561,14 +1564,14 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE radiation_init
-    
+
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i         !< running index x-direction 
+       INTEGER(iwp) ::  i         !< running index x-direction
        INTEGER(iwp) ::  is        !< running index for input surface elements
-       INTEGER(iwp) ::  ioff      !< offset in x between surface element reference grid point in atmosphere and actual surface 
-       INTEGER(iwp) ::  j         !< running index y-direction 
-       INTEGER(iwp) ::  joff      !< offset in y between surface element reference grid point in atmosphere and actual surface 
+       INTEGER(iwp) ::  ioff      !< offset in x between surface element reference grid point in atmosphere and actual surface
+       INTEGER(iwp) ::  j         !< running index y-direction
+       INTEGER(iwp) ::  joff      !< offset in y between surface element reference grid point in atmosphere and actual surface
        INTEGER(iwp) ::  k         !< running index z-direction
-       INTEGER(iwp) ::  l         !< running index for orientation of vertical surfaces 
+       INTEGER(iwp) ::  l         !< running index for orientation of vertical surfaces
        INTEGER(iwp) ::  m         !< running index for surface elements
        INTEGER(iwp) ::  ntime = 0 !< number of available external radiation timesteps
@@ -1584,5 +1587,5 @@
 !      or if biometeorology output is required for flat surfaces.
 !--    The namelist parameter radiation_interactions_on can override this behavior.
-!--    (This check cannot be performed in check_parameters, because vertical_surfaces_exist is first set in 
+!--    (This check cannot be performed in check_parameters, because vertical_surfaces_exist is first set in
 !--    init_surface_arrays.)
        IF ( radiation_interactions_on )  THEN
@@ -1591,10 +1594,10 @@
              average_radiation         = .TRUE.
           ELSE
-             radiation_interactions_on = .FALSE.   !< reset namelist parameter: no interactions 
+             radiation_interactions_on = .FALSE.   !< reset namelist parameter: no interactions
                                                    !< calculations necessary in case of flat surface
           ENDIF
        ELSEIF ( vertical_surfaces_exist  .OR.  plant_canopy  .OR.  biometeorology )  THEN
           message_string = 'radiation_interactions_on is set to .FALSE. although '     // &
-                           'vertical surfaces and/or trees or biometeorology exist '   // & 
+                           'vertical surfaces and/or trees or biometeorology exist '   // &
                            'is ON. The model will run without RTM (no shadows, no '    // &
                            'radiation reflections)'
@@ -1607,5 +1610,5 @@
 
 !
-!--    If required, initialize radiation interactions between surfaces 
+!--    If required, initialize radiation interactions between surfaces
 !--    via sky-view factors. This must be done before radiation is initialized.
        IF ( radiation_interactions )  CALL radiation_interaction_init
@@ -1615,10 +1618,10 @@
                   surf_lsm_h%ns > 0  )   THEN
           ALLOCATE( surf_lsm_h%rad_net(1:surf_lsm_h%ns) )
-          surf_lsm_h%rad_net = 0.0_wp 
+          surf_lsm_h%rad_net = 0.0_wp
        ENDIF
        IF ( .NOT. ALLOCATED ( surf_usm_h%rad_net )  .AND.                      &
                   surf_usm_h%ns > 0  )  THEN
           ALLOCATE( surf_usm_h%rad_net(1:surf_usm_h%ns) )
-          surf_usm_h%rad_net = 0.0_wp 
+          surf_usm_h%rad_net = 0.0_wp
        ENDIF
        DO  l = 0, 3
